unless file_loaded?(__FILE__)
	UI.menu("Plugins").add_item("By Increment") { Sketchup.active_model.select_tool SDM::By_Increment.new }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	class By_Increment
		
		def initialize
			@mod=Sketchup.active_model
			@ent=@mod.active_entities
			@ip=Sketchup::InputPoint.new
			@increment ||= 1.cm; @dist = 0; @draging = false
		end
		
		def onMouseMove(flags, x, y, view)
			@ip.pick view,x,y; view.tooltip = @ip.tooltip; view.refresh
			Sketchup::set_status_text"Click and Drag to define line. Esc to exit",SB_PROMPT
			if @draging
				Sketchup::set_status_text "Length:", SB_VCB_LABEL
				Sketchup::set_status_text Sketchup.format_length(@dist), SB_VCB_VALUE
			else
				Sketchup::set_status_text "Increment:",SB_VCB_LABEL
				Sketchup::set_status_text Sketchup.format_length(@increment), SB_VCB_VALUE
			end
		end
		
		def onLButtonDown(flags, x, y, view)
			@draging=true
			@start_point=@ip.position
		end
		
		def onLButtonUp(flags, x, y, view)
			@draging = false
			if @end_point
				@ent.add_line @start_point,@end_point
			end
		end
		
		def onCancel(flags,view)
			Sketchup.send_action "selectSelectionTool:"
		end
		
		def onUserText(text, view)
			begin
				@increment = text.to_l
				Sketchup::set_status_text Sketchup.format_length(@increment), SB_VCB_VALUE
			rescue
				UI.beep
			end
		end
		 
		def draw(view)
			if( @ip.valid? && @ip.display? )
				@ip.draw(view)
			end
			# 
			if @draging
				@dist = @start_point.distance(@ip.position)
				if @dist >= @increment/2.0
					@dist = (@dist/@increment).ceil * @increment
					vect = @ip.position - @start_point
					@end_point = @start_point.offset(vect,@dist)
					view.drawing_color = 'yellow'
					view.line_width = 3
					view.draw_line @start_point,@end_point
				else
					@end_point = nil; @dist = 0
				end
			end
			
		end
		
	end
	
end
